using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using TIS.Imaging;

namespace VCD_Property_Page
{
    public partial class VCDPropertiesDlg : Form
    {
        private TIS.Imaging.ICImagingControl icImagingControl;

        // ݃Rg[Ŗ߂ĂJeS̃t[
        private System.Windows.Forms.GroupBox currentFrame;

        // XCb``FbNA𑁂邽߂ɃRNVg
        private System.Collections.ArrayList currentSisterControls;
        private System.Collections.ArrayList currentSisterSliders;

        // O[oIuWFNgXVꂽƂɓ삷
        private readonly System.Collections.ArrayList allControls = new System.Collections.ArrayList();

        // ̒萔́AvpeBy[W̃CAEg𐧌䂵܂
        private const int CTRL_HEIGHT = 27;
        private const int ROW_HEIGHT = 28;
        private const int PAGE_WIDTH = 800;

        private const int LABEL_WIDTH = 100;
        private const int SLIDER_WIDTH = 580;

        private const int COMBO_EXTRA_WIDTH = 280;
        private const int BUTTON_EXTRA_WIDTH = 20;
        private const int CHECK_EXTRA_WIDTH = 27;

        private const int CTRL_MARGIN = 3;

        public VCDPropertiesDlg( TIS.Imaging.ICImagingControl ic )
        {
            icImagingControl = ic;
            InitializeComponent();
        }

        private void VCDPropertiesDlg_Load(object sender, EventArgs e)
        {
            int height = 7;

            // JeS[̌JԂ
            foreach (string Cat in icImagingControl.VCDPropertyItems.CategoryMap.Categories)
            {
                int subHeight;
                // JeS̃t[ƃRg[}܂
                InsertCategory(Cat, 7, height, PAGE_WIDTH - 14, out subHeight);
                height = height + subHeight;
            }

            // y[W̃TCYύXA{^̈ʒu𒲐܂
            this.Width = PAGE_WIDTH;
            this.Height = height + OKButton.Height + 14 + 14 + 7;
            OKButton.Top = height;
            OKButton.Left = this.Width - 14 - OKButton.Width;
            UpdateButton.Top = height;
            UpdateButton.Left = OKButton.Left - 7 - UpdateButton.Width;
            this.Height = 500;

        }

        private void UpdateControls()
        {
            // Rg[[XV
            icImagingControl.VCDPropertyItems.Update();
            foreach (IControlBase ctl in allControls)
            {
                ctl.UpdateControl();
            }
        }

        private void UpdateButton_Click(object sender, EventArgs e)
        {
            UpdateButton.Enabled = false;
            UpdateControls();
            UpdateButton.Enabled = true;
        }

        private void OKButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }     

        private void CreateCategoryFrame(string name, int left, int top, int width)
        {

            // t[IuWFNg쐬
            System.Windows.Forms.GroupBox frm = new System.Windows.Forms.GroupBox();
            frm.Name = "Group" + allControls.Count;
            this.Controls.Add(frm);

            frm.Text = Name;
            frm.SetBounds(left, top, width, 0);

            // O[oȃt[IuWFNgKp
            currentFrame = frm;
        }

        private void CreatePropertyLabel(string name, int left, int top, int width, int height)
        {

            // xIuWFNg쐬
            System.Windows.Forms.Label lbl = new System.Windows.Forms.Label();
            lbl.Name = "Label" + allControls.Count;
            currentFrame.Controls.Add(lbl);

            lbl.SetBounds(left, top, width, height);
            lbl.Text = name;
        }

        private void CreateRangeSlider(TIS.Imaging.VCDRangeProperty itf, int left, int top, int width, int height)
        {
            // RangeSlider control쐬
            RangeSlider Slider = new RangeSlider( itf );
            Slider.Name = "slider" + allControls.Count;
            currentFrame.Controls.Add(Slider);

            Slider.SetBounds(left, top, width, height);

            // sistercontrols collectionǉ
            currentSisterControls.Add(Slider);
            //  sistersliders collectionǉ
            currentSisterSliders.Add(Slider);

            //Rg[the sistersliders groupn
            Slider.setSisterSliders(currentSisterSliders);

            // O[oXgRg[ɒǉ
            allControls.Add(Slider);
        }

        private void CreateAbsValSlider(TIS.Imaging.VCDAbsoluteValueProperty itf, int left, int top, int width, int height)
        {

            // VCDAbsoluteValuePropertyɑΉXC_[쐬
            AbsValSlider Slider = new AbsValSlider( itf );
            Slider.Name = "absvalslider" + allControls.Count;
            currentFrame.Controls.Add(Slider);

            Slider.SetBounds(left, top, width, height);

            // sistercontrols collectionǉ
            currentSisterControls.Add(Slider);
            // sistersliders collectionǉ
            currentSisterSliders.Add(Slider);

            // Rg[the sistersliders groupn
            Slider.setSisterSliders(currentSisterSliders);

            // O[oXgRg[ɒǉ
            allControls.Add(Slider);
        }

        private void CreateSwitch(TIS.Imaging.VCDSwitchProperty itf, int left, int top, int width, int height)
        {
            //  Switch Control쐬
            Switch swtch = new Switch( itf );
            swtch.Name = "switch" + allControls.Count;
            currentFrame.Controls.Add(swtch);

            swtch.SetBounds(left, top, width, height);

            // sistercontrols collectionǉ
            currentSisterControls.Add(swtch);

            // Rg[the sistersliders groupn
            swtch.setSisterControls(currentSisterControls);

            // O[oXgRg[ɒǉ
            allControls.Add(swtch);
        }

        private void CreateButton(TIS.Imaging.VCDButtonProperty itf, int left, int top, int width, int height)
        {
            //  PushButton controlǉ
            PushButton btn = new PushButton( itf );
            btn.Name = "button" + allControls.Count;
            currentFrame.Controls.Add(btn);

            btn.SetBounds(left, top, width, height);

            // sistercontrols collectionɃRg[ǉ
            currentSisterControls.Add(btn);

            // Rg[the sistersliders groupn
            btn.setSisterControls(currentSisterControls);

            // O[oXgRg[ɒǉ
            allControls.Add(btn);
        }

        private void CreateCombo(TIS.Imaging.VCDMapStringsProperty itf, int left, int top, int width, int height)
        {
            // StringCombo controlǉ
            StringCombo cbo = new StringCombo( itf );
            cbo.Name = "combo" + allControls.Count;
            currentFrame.Controls.Add(cbo);

            cbo.SetBounds(left, top, width, height);

            // sistercontrols collectionɃRg[ǉ
            currentSisterControls.Add(cbo);
            // sistersliders collectionɃRg[ǉ
            currentSisterSliders.Add(cbo);

            // Rg[the sistersliders groupn
            cbo.setSisterSliders(currentSisterSliders);

            // O[oXgRg[ɒǉ
            allControls.Add(cbo);
        }

        private void InsertElement(TIS.Imaging.VCDPropertyElement elem, ref int x, ref int y, string txt)
        {
            // ׂẴC^[tF[X錾
            VCDAbsoluteValueProperty AbsValItf = elem.Find<VCDAbsoluteValueProperty>();
            VCDMapStringsProperty MapStringsItf = elem.Find<VCDMapStringsProperty>();
            VCDRangeProperty RangeItf = elem.Find<VCDRangeProperty>();
            VCDSwitchProperty SwitchItf = elem.Find<VCDSwitchProperty>();
            VCDButtonProperty buttonItf = elem.Find<VCDButtonProperty>();

            
            // XC_[ŕ\AXC_[ɂ̓vpeB̖O\Ȃ
            // VCDAbsoluteValuePropertyAVCDMapStringsPropertyAVCDRangePropertŷƂɃxpӂB
            int labelWidth = 0;
            if ((AbsValItf != null || MapStringsItf != null || RangeItf != null) && (txt != ""))
            {
                labelWidth = TextWidth(txt);
                if (labelWidth < LABEL_WIDTH)
                {
                    labelWidth = LABEL_WIDTH;
                }

                CreatePropertyLabel(txt, x, y + CTRL_HEIGHT / 4, labelWidth, CTRL_HEIGHT / 4 * 3);
                x = x + labelWidth;
            }

            int w = 0;

            // VCDAbsoluteValueProperty擾łꍇ́AK؂ȃXC_[쐬
            if (AbsValItf != null)
            {

                CreateAbsValSlider(AbsValItf, x, y, SLIDER_WIDTH, CTRL_HEIGHT);
                x = x + SLIDER_WIDTH + CTRL_MARGIN;

                // VCDMapStringsProperty擾łꍇ́AR{{bNX쐬
            }
            else if (MapStringsItf != null)
            {

                // Gg̕ɊÂāAR{{bNX̕KvwithvZ܂
                int boxWidth = 0;
                foreach (string s in MapStringsItf.Strings)
                {
                    w = TextWidth(s);
                    if (w > boxWidth)
                    {
                        boxWidth = w;
                    }
                }

                // hbv_E{^pɃXy[Xǉ܂
                boxWidth = boxWidth + COMBO_EXTRA_WIDTH;

                CreateCombo(MapStringsItf, x, y, boxWidth, CTRL_HEIGHT);
                x = x + boxWidth + CTRL_MARGIN;

                // ͈̓C^[tFCX擾łꍇ́A͈̓XC_[쐬܂
            }
            else if (RangeItf != null)
            {

                CreateRangeSlider(RangeItf, x, y, SLIDER_WIDTH, CTRL_HEIGHT);
                x = x + SLIDER_WIDTH + CTRL_MARGIN;

                // VCDSwitchProperty擾ꍇ́AXCb``FbN{bNX쐬܂
            }
            else if (SwitchItf != null)
            {
                // XCb`Rg[̕Kvȕ肷
                int switchWidth = TextWidth(elem.Name);
                switchWidth = switchWidth + CHECK_EXTRA_WIDTH;

                CreateSwitch(SwitchItf, x, y, switchWidth, CTRL_HEIGHT);
                x = x + switchWidth + CTRL_MARGIN;

            
            }
            // {^Rg[쐬
            else if (buttonItf != null)
            {
                //{^Rg[̕Kvȕ肷
                int buttonWidth = TextWidth(elem.Name);
                buttonWidth = buttonWidth + BUTTON_EXTRA_WIDTH;

                CreateButton(buttonItf, x, y, buttonWidth, CTRL_HEIGHT);
                x = x + buttonWidth + CTRL_MARGIN;
            }

        }

        private void InsertItem(TIS.Imaging.VCDPropertyItem item, ref int y)
        {
            int x = 20;

            // valueAutoOne Push̃ACeT
            VCDPropertyElement valueElem = item.Elements.FindElement(TIS.Imaging.VCDGUIDs.VCDElement_Value);
            VCDPropertyElement autoElem = item.Elements.FindElement(TIS.Imaging.VCDGUIDs.VCDElement_Auto);
            VCDPropertyElement onepushElem = item.Elements.FindElement(TIS.Imaging.VCDGUIDs.VCDElement_OnePush);


            //zCgoX͗O
            if (item.ItemGUID == TIS.Imaging.VCDGUIDs.VCDID_WhiteBalance)
            {
                if (item.Elements.FindElement(TIS.Imaging.VCDGUIDs.VCDElement_WhiteBalanceRed) != null)
                {
                    valueElem = null;
                }
            }

            // x̓K؂ȃTCYɒ
            int labelWidth = TextWidth(item.Name);
            if (labelWidth < LABEL_WIDTH)
            {
                labelWidth = LABEL_WIDTH;
            }

            CreatePropertyLabel(item.Name, x, y + CTRL_HEIGHT / 4, labelWidth, CTRL_HEIGHT / 4 * 3);
            x = x + labelWidth + CTRL_MARGIN;

            // valueAutoOne Push̃ACe쐬
            if (valueElem != null)
            {
                InsertElement(valueElem, ref x, ref y, "");
            }
            if (autoElem != null)
            {
                InsertElement(autoElem, ref x, ref y, "");
            }
            if (onepushElem != null)
            {
                InsertElement(onepushElem, ref x, ref y, "");
            }

            y = y + ROW_HEIGHT;

            // valueAutoOne PushȊÕRg[͍쐬Ȃ
            foreach (TIS.Imaging.VCDPropertyElement elem in item.Elements)
            {
                Guid guid = elem.ElementGUID;

                if (guid != TIS.Imaging.VCDGUIDs.VCDElement_Value & guid != TIS.Imaging.VCDGUIDs.VCDElement_Auto & guid != VCDGUIDs.VCDElement_OnePush)
                {

                    x = 25;
                    InsertElement(elem, ref x, ref y, elem.Name);
                    y = y + ROW_HEIGHT;

                }
            }
        }

        private void InsertCategory(string category, int left, int top, int right, out int height)
        {
            int y = 20;


            // JeSɑ΂t[쐬
            CreateCategoryFrame(category, left, top, right - left);

            
            // ̃JeSɑ΂VRg[O[v쐬
            currentSisterControls = new System.Collections.ArrayList();

            // ̃JeS[̒̃ACeTAACeǉ
            foreach (Guid itemID in icImagingControl.VCDPropertyItems.CategoryMap.ItemIDs[category])
            {
                TIS.Imaging.VCDPropertyItem item = icImagingControl.VCDPropertyItems.FindItem(itemID);
                // Rg[}
                if (item != null)
                {
                    currentSisterSliders = new System.Collections.ArrayList();
                    InsertItem(item, ref y);
                }
            }

            // t[̍𒲐
            currentFrame.Height = y + 7;

            // t[̍Rg[
            height = y + 14;
        }

        private void UpdateTimer_Tick(object sender, EventArgs e)
        {
            UpdateControls();
        }

        private int TextWidth(string s)
        {
            System.Drawing.Graphics g = this.CreateGraphics();
            int w = (int)g.MeasureString(s, this.Font).Width + 7;
            g.Dispose();
            return w;
        }
    }
}